var Adresar = new function() {
	var UserStorage = new function() {
		var userFullNames = [
			"Květa Blažková",
			"Tomáš Holub",
			"Pavla Horáková",
			"Vladimíra Němcová",
			"Erik Pospíšil",
			"Adéla Šťastná"
		],
		userData = [
			null,
			{
				firstname: "Tomáš",
				surname: "Holub"
			},
			{
				firstname: "Pavla",
				surname: "Horáková",
				tags: ["#kamoska", "#spoluzacka", "#volejbal"],
				email: {
					"Hlavní e-mail": "hora.pavla@seznam.cz",
					"Pracovní e-mail": "pavla@horakova.cz"
				},
				tel: {
					"Mobil": "+420 737 028 937",
					"Staré číslo": "+420 601 429 361",
					"Fax": "387 390 419"
				},
				address: {
					street: "Silvenecká 9",
					psc: "940 15",
					town: "Žlutice"
				}
			}
		];
		this.getFullNames = function() {
			return userFullNames;
		}
		this.getUserDataByIndex = function(userIdx) {
			return userData[userIdx];
		}
		
	}
	var ContactDetail = new function() {
		var self = this;
		this.mainNode = null;
		this.createUI = function() {
			var cont = document.createElement("div");
			cont.className = "contact-detail";
			this.mainNode = cont;
			
				var name = document.createElement("h2");
				this.nameNode = name;
				cont.appendChild(name);
			
				var avatarCont = document.createElement("div");
				avatarCont.className = "avatar-container";
			
					var avatarImg = document.createElement("img");
					avatarImg.className = "avatar";
					this.avatarImgNode = avatarImg;
					avatarCont.appendChild(avatarImg);
					
					var editBut = document.createElement("button");
					editBut.className = "edit-button";
					editBut.innerHTML = '<span class="icon edit"></span>Upravit';
					avatarCont.appendChild(editBut);
			
				cont.appendChild(avatarCont);
				
				var table = document.createElement("table");
				this.tableNode = table;
				cont.appendChild(table);
			
			var container = document.getElementById("content");
			container.appendChild(cont);
			
		}
		var keyNameMap = {
			firstname: "Jméno",
			surname: "Příjmení",
			tags: "Štítky",
			address: "Adresa"
		};
		this.showUserData = function(fullName, userData) {
			this.nameNode.innerHTML = fullName;
			this.avatarImgNode.src = "icons/user.svg";
			var tref = this.tableNode;
			tref.innerHTML = "";
			function nextRow(key, value) {
				var tr = tref.insertRow(),
					th = document.createElement("th");
				th.innerHTML = key + ":";
				tr.appendChild(th);
				var td = tr.insertCell();
				td.innerHTML = value;
			}
			for(var key in userData) {
				var curVal = userData[key];
				if(typeof curVal === "string") {
					nextRow(keyNameMap[key], curVal);
				} else if(key === "tags") {
					nextRow(keyNameMap[key], curVal.join(", "));
				} else if(key === "address") {
					nextRow(keyNameMap[key], userData.address.street + "<br>" + userData.address.psc + " " + userData.address.town);
				} else {
					for(var keyx in userData[key]) {
						var valuex = userData[key][keyx];
						console.log(key);
						if(key === "email") {
							valuex = '<a href="mailto:'+valuex+'">' + valuex + '</a>';
						} else if(key === "tel") {
							valuex = '<a href="tel:'+valuex.split(" ").join("")+'">' + valuex + '</a>';
						}
						nextRow(keyx, valuex);
					}
				}
			}
		}
		this.show = function() {
			this.mainNode.className = "contact-detail visible";
		}
		this.hide = function() {
			this.mainNode.className = "contact-detail";
		}
		var init = function() {
			self.createUI();
		}();
	}
	var self = this;
	this.selectedUserIdx = undefined;
	this.showContactInfo = function(userIdx) {
		ContactDetail.hide();
		ContactDetail.showUserData(UserStorage.getFullNames()[userIdx], UserStorage.getUserDataByIndex(userIdx));
		ContactDetail.show();
	}
	function contactLinkClickHandler() {
		if(self.selectedUserIdx !== undefined) {
			self.contactListNode.getElementsByTagName("li")[self.selectedUserIdx].className = "";
		}
		this.className = "selected";
		var useridx = Number(this.getAttribute("data-idx"));
		self.showContactInfo(useridx);
		self.selectedUserIdx = useridx;
	}
	this.fillUpContactList = function() {
		var miniDOM = document.createDocumentFragment();
		var fullNames = UserStorage.getFullNames(),
			fullNamesLen = fullNames.length;
		for(var i = 0; i < fullNamesLen; i++) {
			var li = document.createElement("li");
			li.innerHTML = fullNames[i];
			li.setAttribute("data-idx", i);
			li.addEventListener("click", contactLinkClickHandler);
			miniDOM.appendChild(li);
		}
		this.contactListNode.appendChild(miniDOM);
	}
	this.fillUpDir = function() {
		var html = "";
		for(var i = 65; i <= 90; i++) { // 65 - 90  =  A - Z
			html += "<li>" + String.fromCharCode(i) + "</li>";
		}
		this.dirNode.innerHTML = html;
	}
	this.bindElements = function() {
		var contactList = document.getElementById("contact-list");
		this.contactListNode = contactList;
		var aDir = document.getElementById("a-dir");
		this.dirNode = aDir;
	}
	var init = function() {
		self.bindElements();
		self.fillUpContactList();
		self.fillUpDir();
	}()
}